/*
 * Copyright (c) 2021 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "dbus_mock.h"

#include "mock_hook.h"
#include "test_fixture.h"

extern "C" GDBusConnection* g_bus_get_sync(GBusType bus_type,
    GCancellable* cancellable, GError** error) {
  return MOCK_HOOK_P3(DbusMock, g_bus_get_sync, bus_type, cancellable, error);
}

extern "C" GDBusProxy* g_dbus_proxy_new_sync(GDBusConnection* arg1,
    GDBusProxyFlags arg2, GDBusInterfaceInfo* arg3, const gchar* arg4,
    const gchar* arg5, const gchar* arg6, GCancellable* arg7, GError** arg8) {
  return MOCK_HOOK_P8(DbusMock, g_dbus_proxy_new_sync, arg1, arg2,
      arg3, arg4, arg5, arg6, arg7, arg8);
}

extern "C" GDBusNodeInfo* g_dbus_node_info_new_for_xml(const gchar* arg1,
    GError** arg2) {
  return MOCK_HOOK_P2(DbusMock, g_dbus_node_info_new_for_xml, arg1, arg2);
}

extern "C" guint g_bus_own_name_on_connection(GDBusConnection* arg1,
    const gchar* arg2, GBusNameOwnerFlags arg3, GBusNameAcquiredCallback arg4,
    GBusNameLostCallback arg5, gpointer arg6, GDestroyNotify arg7) {
  return MOCK_HOOK_P7(DbusMock, g_bus_own_name_on_connection, arg1, arg2,
      arg3, arg4, arg5, arg6, arg7);
}

extern "C" guint g_dbus_connection_register_object(GDBusConnection* arg1,
    const gchar* arg2, GDBusInterfaceInfo* arg3,
    const GDBusInterfaceVTable* arg4, gpointer arg5, GDestroyNotify arg6,
    GError** arg7) {
  return MOCK_HOOK_P7(DbusMock, g_dbus_connection_register_object, arg1, arg2,
      arg3, arg4, arg5, arg6, arg7);
}

extern "C" gboolean g_dbus_connection_unregister_object(GDBusConnection* arg1,
    guint arg2) {
  return MOCK_HOOK_P2(DbusMock, g_dbus_connection_unregister_object, arg1,
      arg2);
}

extern "C" void g_dbus_method_invocation_return_value(
    GDBusMethodInvocation* arg1, GVariant* arg2) {
  MOCK_HOOK_P2(DbusMock, g_dbus_method_invocation_return_value, arg1, arg2);
}

extern "C" void g_bus_unown_name(guint arg1) {
  MOCK_HOOK_P1(DbusMock, g_bus_unown_name, arg1);
}

extern "C" gboolean g_dbus_connection_emit_signal(GDBusConnection* arg1,
    const gchar* arg2, const gchar* arg3, const gchar* arg4, const gchar* arg5,
    GVariant* arg6, GError** arg7) {
  return MOCK_HOOK_P7(DbusMock, g_dbus_connection_emit_signal, arg1, arg2,
      arg3, arg4, arg5, arg6, arg7);
}

extern "C" gboolean g_dbus_connection_flush_sync(GDBusConnection* arg1,
    GCancellable* arg2, GError** arg3) {
  return MOCK_HOOK_P3(DbusMock, g_dbus_connection_flush_sync, arg1, arg2,
      arg3);
}

extern "C" void g_dbus_node_info_unref(GDBusNodeInfo* arg1) {
  MOCK_HOOK_P1(DbusMock, g_dbus_node_info_unref, arg1);
}

extern "C" guint g_dbus_connection_signal_subscribe(GDBusConnection* arg1,
    const gchar* arg2, const gchar* arg3, const gchar* arg4, const gchar* arg5,
    const gchar* arg6, GDBusSignalFlags arg7, GDBusSignalCallback arg8,
    gpointer arg9, GDestroyNotify arg10) {
  return MOCK_HOOK_P10(DbusMock, g_dbus_connection_signal_subscribe, arg1, arg2,
      arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);
}

extern "C" GVariant* g_dbus_proxy_call_sync(GDBusProxy* arg1,
    const gchar* arg2, GVariant* arg3, GDBusCallFlags arg4, gint arg5,
    GCancellable* arg6, GError** arg7) {
  return MOCK_HOOK_P7(DbusMock, g_dbus_proxy_call_sync, arg1, arg2,
      arg3, arg4, arg5, arg6, arg7);
}

extern "C" void g_dbus_proxy_call(GDBusProxy* arg1, const gchar* arg2,
    GVariant* arg3, GDBusCallFlags arg4, gint arg5, GCancellable* arg6,
    GAsyncReadyCallback arg7, gpointer arg8) {
  return MOCK_HOOK_P8(DbusMock, g_dbus_proxy_call, arg1, arg2,
      arg3, arg4, arg5, arg6, arg7, arg8);
}
