/*
 * Copyright (c) 2021 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "pkgmgr_info_mock.h"

#include "mock_hook.h"
#include "test_fixture.h"

extern "C" int pkgmgrinfo_pkginfo_get_usr_pkginfo(const char* arg1, uid_t arg2,
    pkgmgrinfo_pkginfo_h* arg3) {
  return MOCK_HOOK_P3(PkgmgrInfoMock, pkgmgrinfo_pkginfo_get_usr_pkginfo, arg1,
      arg2, arg3);
}

extern "C" int pkgmgrinfo_pkginfo_get_api_version(pkgmgrinfo_pkginfo_h arg1,
    char** arg2) {
  return MOCK_HOOK_P2(PkgmgrInfoMock, pkgmgrinfo_pkginfo_get_api_version, arg1,
      arg2);
}

extern "C" int pkgmgrinfo_pkginfo_is_global(pkgmgrinfo_pkginfo_h arg1,
    bool* arg2) {
  return MOCK_HOOK_P2(PkgmgrInfoMock, pkgmgrinfo_pkginfo_is_global, arg1,
      arg2);
}

extern "C" int pkgmgrinfo_pkginfo_destroy_pkginfo(pkgmgrinfo_pkginfo_h arg1) {
  return MOCK_HOOK_P1(PkgmgrInfoMock, pkgmgrinfo_pkginfo_destroy_pkginfo,
      arg1);
}

extern "C" int pkgmgrinfo_appinfo_get_usr_appinfo(const char* arg1, uid_t arg2,
    pkgmgrinfo_appinfo_h* arg3) {
  return MOCK_HOOK_P3(PkgmgrInfoMock, pkgmgrinfo_appinfo_get_usr_appinfo, arg1,
      arg2, arg3);
}

extern "C" int pkgmgrinfo_appinfo_get_pkgid(pkgmgrinfo_pkginfo_h arg1,
    char** arg2) {
  return MOCK_HOOK_P2(PkgmgrInfoMock, pkgmgrinfo_appinfo_get_pkgid, arg1,
      arg2);
}

extern "C" int pkgmgrinfo_appinfo_get_component_type(pkgmgrinfo_appinfo_h arg1,
    char** arg2) {
  return MOCK_HOOK_P2(PkgmgrInfoMock, pkgmgrinfo_appinfo_get_component_type, arg1,
      arg2);
}

extern "C" int pkgmgrinfo_appinfo_destroy_appinfo(pkgmgrinfo_appinfo_h arg1) {
  return MOCK_HOOK_P1(PkgmgrInfoMock, pkgmgrinfo_appinfo_destroy_appinfo,
      arg1);
}
