/*
 * Copyright (c) 2015 - 2019 Samsung Electronics Co., Ltd All Rights Reserved
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#include<stdio.h>
#include<stdlib.h>
#include<glib.h>

#include "alarm.h"

int callback(alarm_id_t alarm_id, void* user_param)
{
	time_t current_time;
	time(&current_time);

	printf("Alarm[%d] has expired at %s\n", alarm_id, ctime(&current_time));

	return 0;
}

void create_test()
{
	int result = 0;
	alarm_id_t alarm_id;

	result = alarmmgr_add_reference_periodic_alarm_withcb(1, callback, NULL, &alarm_id);

	if (result < 0)
		printf("alarmmgr_add_reference_periodic_alarm_withcb : error_code : %d\n", result);
}

int main(int argc, char** argv)
{
	GMainLoop *mainloop;
	int result;

	mainloop = g_main_loop_new(NULL, FALSE);
	result = alarmmgr_init("org.tizen.alarmmgr.refperiodic");

	if (result < 0)
		printf("fail to alarmmgr_init : error_code : %d\n", result);
	else
		create_test();

	g_main_loop_run(mainloop);

	return 0;
}

